<?php
global $ua_browsers, $ua_systems;
$ua_browsers = array("firefox", "msie", "opera mini", "opera", "chrome", "safari",
                    "seamonkey", "konqueror", "netscape", "netfront",
                    "gecko", "navigator", "mosaic", "lynx", "amaya",
                    "omniweb", "avant", "camino", "flock", "aol", "mozilla");
$ua_systems = array('windows nt 5.0' => array('Windows','2000'), 'windows nt 5.1' => array('Windows','XP'),
                    'windows nt 5.2' => array('Windows','XP'), 'windows nt 6.0' => array('Windows','Vista'),
                    'windows nt 6.1' => array('Windows','7'), 'windows nt' => array('Windows','NT'), 
                    'windows|win32' => array('Windows',''), 
                    'android ([\d\.]+)' => array('Android',''),
                    '(?:ipod|iphone|ipad).*([\d\._]+)?\s+like mac os x' => array('iOS',''),
                    'mac os x (\d+[\._]\d+)' => array('Mac OS X',''),
                    'ubuntu/([\d\.]+)' => array('Ubuntu',''), 'linux' => array('Linux',''), 
                    'j2me' => array('J2ME',''), 'midp' => array('J2ME',''));

function ua_get_browser($ua) {
  global $ua_browsers;
  foreach ($ua_browsers as $browser) {
    if (preg_match("#($browser)[/ ]?([^/\s]*)#i", $ua, $match)) {
      return array($match[1], $match[2]);
    }
  }
  return array(null, null);
}

function ua_get_os($ua) {
  global $ua_systems;
  foreach ($ua_systems as $system => $nameAndVersion) {
    if (preg_match("#$system#", strtolower($ua), $match)) {
      return array($nameAndVersion[0], (isset($match[1]) ? ' '.preg_replace('/_/','.',$match[1]) : $nameAndVersion[1]));
    }
  }
  return array(null, null);
}

function ua_get_language($ua) {
  if (preg_match("#[;(]\s*([a-z][a-z](?:-[a-z][a-z])?)[;)]#", strtolower($ua), $match)) {
    return strtolower(substr($match[1],0,2)) . strtoupper(substr($match[1],2));
  }
  return null;
}

